## org.apache.mahout.math
Class MatrixView

    java.lang.Object
      org.apache.mahout.math.AbstractMatrix
          org.apache.mahout.math.MatrixView

All Implemented Interfaces:
  Cloneable, Iterable<MatrixSlice>, Matrix, VectorIterable

    public class MatrixView

extends AbstractMatrix

Implements subset view of a Matrix

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.mahout.math.AbstractMatrix
`AbstractMatrix.TransposeViewVector`

Field Summary

Fields inherited from class org.apache.mahout.math.AbstractMatrix
`COL, columnLabelBindings, columns, ROW, rowLabelBindings, rows`

Constructor Summary
`MatrixView(Matrix matrix, int[] offset, int[] size)` Construct a view of the matrix with given offset and cardinality

Method Summary
`Matrix` `assignColumn(int column, Vector other)` Assign the other vector values to the column of the receiver
`Matrix` `assignRow(int row, Vector other)` Assign the other vector values to the row of the receiver
`Matrix` `clone()` Return a copy of the recipient
`int[]` `getNumNondefaultElements()` Return the number of values in the recipient
`double` `getQuick(int row, int column)` Return the value at the given indexes, without checking bounds
`Matrix` `like()` Return an empty matrix of the same underlying class as the receiver
`Matrix` `like(int rows, int columns)` Returns an empty matrix of the same underlying class as the receiver and of the specified size.
`void` `setQuick(int row, int column, double value)` Set the value at the given index, without checking bounds
`Vector` `viewColumn(int column)` Returns a view of a row.
`Matrix` `viewPart(int[] offset, int[] size)` Return a view into part of a matrix.
`Vector` `viewRow(int row)` Returns a view of a row.

Methods inherited from class org.apache.mahout.math.AbstractMatrix

`aggregate, aggregateColumns, aggregateRows, asFormatString, assign, assign, assign, assign, assign, columnSize, determinant, divide, get, get, getColumnLabelBindings, getRowLabelBindings, iterateAll, iterator, minus, numCols, numRows, numSlices, plus, plus, rowSize, set, set, set, set, set, set, setColumnLabelBindings, setRowLabelBindings, times, times, times, timesSquared, toString, transpose, viewDiagonal, viewPart, zSum`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### MatrixView

    public MatrixView(Matrix matrix,
                      int[] offset,
                      int[] size)

  Construct a view of the matrix with given offset and cardinality

  Parameters:
    `matrix` - an underlying Matrix
    `offset` - the int[2] offset into the underlying matrix
    `size` - the int[2] size of the view

Method Detail

### clone

    public Matrix clone()

  Description copied from interface: `Matrix`
  Return a copy of the recipient

  Specified by:
    `clone` in interface `Matrix`
  Overrides:
    `clone` in class `AbstractMatrix`
  Returns:
    a new Matrix

### getQuick

    public double getQuick(int row,
                           int column)

  Description copied from interface: `Matrix`
  Return the value at the given indexes, without checking bounds

  Parameters:
    `row` - an int row index
    `column` - an int column index
  Returns:
    the double at the index

### like

    public Matrix like()

  Description copied from interface: `Matrix`
  Return an empty matrix of the same underlying class as the receiver

  Returns:
    a Matrix

### like

    public Matrix like(int rows,
                       int columns)

  Description copied from interface: `Matrix`
  Returns an empty matrix of the same underlying class as the receiver and of the specified size.

  Parameters:
    `rows` - the int number of rows
    `columns` - the int number of columns

### setQuick

    public void setQuick(int row,
                         int column,
                         double value)

  Description copied from interface: `Matrix`
  Set the value at the given index, without checking bounds

  Parameters:
    `row` - an int row index into the receiver
    `column` - an int column index into the receiver
    `value` - a double value to set

### getNumNondefaultElements

    public int[] getNumNondefaultElements()

  Description copied from interface: `Matrix`
  Return the number of values in the recipient

  Specified by:
    `getNumNondefaultElements` in interface `Matrix`
  Overrides:
    `getNumNondefaultElements` in class `AbstractMatrix`
  Returns:
    an int[2] containing [row, column] count

### viewPart

    public Matrix viewPart(int[] offset,
                           int[] size)

  Description copied from interface: `Matrix`
  Return a view into part of a matrix. Changes to the view will change the original matrix.

  Specified by:
    `viewPart` in interface `Matrix`
  Overrides:
    `viewPart` in class `AbstractMatrix`
  Parameters:
    `offset` - an int[2] offset into the receiver
    `size` - the int[2] size of the desired result
  Returns:
    a matrix that shares storage with part of the original matrix.

### assignColumn

    public Matrix assignColumn(int column,
                               Vector other)

  Description copied from interface: `Matrix`
  Assign the other vector values to the column of the receiver

  Parameters:
    `column` - the int row to assign
    `other` - a Vector
  Returns:
    the modified receiver

### assignRow

    public Matrix assignRow(int row,
                            Vector other)

  Description copied from interface: `Matrix`
  Assign the other vector values to the row of the receiver

  Parameters:
    `row` - the int row to assign
    `other` - a Vector
  Returns:
    the modified receiver

### viewColumn

    public Vector viewColumn(int column)

  Description copied from class: `AbstractMatrix`
  Returns a view of a row. Changes to the view will affect the original.

  Specified by:
    `viewColumn` in interface `Matrix`
  Overrides:
    `viewColumn` in class `AbstractMatrix`
  Parameters:
    `column` - Which column to return.
  Returns:
    A vector that references the desired column.

### viewRow

    public Vector viewRow(int row)

  Description copied from class: `AbstractMatrix`
  Returns a view of a row. Changes to the view will affect the original.

  Specified by:
    `viewRow` in interface `Matrix`
  Overrides:
    `viewRow` in class `AbstractMatrix`
  Parameters:
    `row` - Which row to return.
  Returns:
    A vector that references the desired row.

Copyright © 2008–2014 The Apache Software Foundation. All rights reserved.